Package org.springframework.http.codec

# Class ServerSentEventHttpMessageWriter

java.lang.Object
org.springframework.http.codec.ServerSentEventHttpMessageWriter

All Implemented Interfaces:
  `HttpMessageWriter<Object>`

public class ServerSentEventHttpMessageWriter extends Object implements HttpMessageWriter<Object>
`HttpMessageWriter` for `"text/event-stream"` responses.

Since:
  5.0
Author:
  Sebastien Deleuze, Arjen Poutsma, Rossen Stoyanchev, Brian Clozel

## Constructor Summary

Constructors
Constructor
Description
`ServerSentEventHttpMessageWriter()`
Constructor without an `Encoder`.
`ServerSentEventHttpMessageWriter(org.springframework.core.codec.Encoder<?> encoder)`
Constructor with JSON `Encoder` for encoding objects.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`canWrite(org.springframework.core.ResolvableType elementType, MediaType mediaType)`
Whether the given object type is supported by this writer.
`org.springframework.core.codec.Encoder<?>`
`getEncoder()`
Return the configured `Encoder`, if any.
`List<MediaType>`
`getWritableMediaTypes()`
Return the list of media types supported by this Writer.
`reactor.core.publisher.Mono<Void>`
`write(Publisher<?> input, org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, MediaType mediaType, ServerHttpRequest request, ServerHttpResponse response, Map<String,Object> hints)`
Server-side only alternative to `HttpMessageWriter.write(Publisher, ResolvableType, MediaType, ReactiveHttpOutputMessage, Map)` with additional context available.
`reactor.core.publisher.Mono<Void>`
`write(Publisher<?> input, org.springframework.core.ResolvableType elementType, MediaType mediaType, ReactiveHttpOutputMessage message, Map<String,Object> hints)`
Write a given stream of object to the output message.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.springframework.http.codec.HttpMessageWriter

`getWritableMediaTypes`

## Constructor Details

### ServerSentEventHttpMessageWriter

public ServerSentEventHttpMessageWriter()
Constructor without an `Encoder`. In this mode only `String` is supported for event data to be encoded.

### ServerSentEventHttpMessageWriter

public ServerSentEventHttpMessageWriter(@Nullable org.springframework.core.codec.Encoder<?> encoder)
Constructor with JSON `Encoder` for encoding objects. Support for `String` event data is built-in.

Parameters:
  `encoder` - the Encoder to use (may be `null`)

## Method Details

### getEncoder

@Nullable public org.springframework.core.codec.Encoder<?> getEncoder()
Return the configured `Encoder`, if any.

### getWritableMediaTypes

public List<MediaType> getWritableMediaTypes()
Description copied from interface: `HttpMessageWriter`
Return the list of media types supported by this Writer. The list may not apply to every possible target element type and calls to this method should typically be guarded via `canWrite(elementType, null)`. The list may also exclude media types supported only for a specific element type. Alternatively, use `HttpMessageWriter.getWritableMediaTypes(ResolvableType)` for a more precise list.

Specified by:
  `getWritableMediaTypes` in interface `HttpMessageWriter<Object>`
Returns:
  the general list of supported media types

### canWrite

public boolean canWrite(org.springframework.core.ResolvableType elementType, @Nullable MediaType mediaType)
Description copied from interface: `HttpMessageWriter`
Whether the given object type is supported by this writer.

Specified by:
  `canWrite` in interface `HttpMessageWriter<Object>`
Parameters:
  `elementType` - the type of object to check
  `mediaType` - the media type for the write (possibly `null`)
Returns:
  `true` if writable, `false` otherwise

### write

public reactor.core.publisher.Mono<Void> write(Publisher<?> input, org.springframework.core.ResolvableType elementType, @Nullable MediaType mediaType, ReactiveHttpOutputMessage message, Map<String,Object> hints)
Description copied from interface: `HttpMessageWriter`
Write a given stream of object to the output message.

Specified by:
  `write` in interface `HttpMessageWriter<Object>`
Parameters:
  `input` - the objects to write
  `elementType` - the type of objects in the stream which must have been previously checked via `HttpMessageWriter.canWrite(ResolvableType, MediaType)`
  `mediaType` - the content type for the write (possibly `null` to indicate that the default content type of the writer must be used)
  `message` - the message to write to
  `hints` - additional information about how to encode and write
Returns:
  indicates completion or error

### write

public reactor.core.publisher.Mono<Void> write(Publisher<?> input, org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, @Nullable MediaType mediaType, ServerHttpRequest request, ServerHttpResponse response, Map<String,Object> hints)
Description copied from interface: `HttpMessageWriter`
Server-side only alternative to `HttpMessageWriter.write(Publisher, ResolvableType, MediaType, ReactiveHttpOutputMessage, Map)` with additional context available.

Specified by:
  `write` in interface `HttpMessageWriter<Object>`
  `actualType` - the actual return type of the method that returned the value; for annotated controllers, the `MethodParameter` can be accessed via `ResolvableType.getSource()`.
  `elementType` - the type of Objects in the input stream
  `mediaType` - the content type to use (possibly `null` indicating the default content type of the writer should be used)
  `request` - the current request
  `response` - the current response
Returns:
  a `Mono` that indicates completion of writing or error